--IMPORTANT-READ THESE TERMS CAREFULLY BEFORE UTILIZING THE INFORMATION CONTAINED IN THIS APPLICATION NOTE. 

--NO SUPPORT/NO WARRANTY.  
--THE DESIGN FILES AND DOCUMENTATION ARE PROVIDED WITHOUT SUPPORT OR WARRANTY OF ANY KIND.  
--ACTEL IS NOT OBLIGATED TO PROVIDE UPDATES, BUG FIXES, OR TECHNICAL SUPPORT AND DISCLAIMS ALL WARRANTIES INCLUDING, 
--WITHOUT LIMITATION, THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND WARRANTIES OF 
--NON-INFRINGEMENT OF THE RIGHTS OF THIRD PARTIES (INCLUDING, WITHOUT LIMITATION, RIGHTS UNDER PATENT, COPYRIGHT, 
--TRADE SECRET, OR OTHER INTELLECTUAL PROPERTY RIGHTS).  RECIPIENT ACCEPTS THE APPLICATION NOTE DESIGN FILES AND 
--DOCUMENTATION IN "AS-IS" CONDITION.


-- FSM_CorePWM.vhd
library ieee;
use ieee.std_logic_1164.all;

entity FSM_CorePWM is
    GENERIC (PWM_NUM :  integer := 1);
	port (PCLK, PRESET_N, PSEL, PENABLE, PWRITE: in std_logic;
          DUTY_CYC: in std_logic_vector (2 downto 0);
          PWM: out std_logic_vector (PWM_NUM downto 1);
          PRDATA: out std_logic_vector (7 downto 0);
          INT: out std_logic);
end entity FSM_CorePWM;

architecture HIERARCHICAL of FSM_CorePWM is
    component FSM
        port (PCLK, PRESET_N: in std_logic;
              DUTY_CYC: in std_logic_vector (2 downto 0);
              PADDR: out std_logic_vector (4 downto 0);
              PWDATA: out std_logic_vector (7 downto 0));
    end component;
    component corepwm
		GENERIC (PWM_NUM :  integer := 8); 
        port (PCLK, PRESET_N, PSEL, PENABLE, PWRITE: in std_logic;
              PADDR: in std_logic_vector(4 downto 0);   
              PWDATA: in std_logic_vector(7 downto 0); 
              PWM: out std_logic_vector(PWM_NUM downto 1);
              PRDATA: out std_logic_vector(7 downto 0);   
              INT: out std_logic);   
    end component;
    signal PADDR_TOP: std_logic_vector(4 downto 0);
    signal PWDATA_TOP: std_logic_vector(7 downto 0);  
begin
    FSM_TOP: FSM port map (PCLK=>PCLK,PRESET_N=>PRESET_N,DUTY_CYC=>DUTY_CYC,PADDR=>PADDR_TOP,PWDATA=>PWDATA_TOP);
    COREPWM_TOP: corepwm 
	GENERIC MAP (PWM_NUM =>PWM_NUM)
	port map (PCLK=>PCLK,PRESET_N=>PRESET_N,PSEL=>PSEL,PENABLE=>PENABLE,PWRITE=>PWRITE,
                                   PADDR=>PADDR_TOP,PWDATA=>PWDATA_TOP,PWM=>PWM,PRDATA=>PRDATA,INT=>INT); 
end HIERARCHICAL;                           
    
    